/**
 * Last Modified by: $Author: rjeffers $
 * On: $Date: 2004/07/16 15:57:44 $
 */
 
package kaos.core.csi;

import java.io.Serializable;


/**
 * Defines the operations to store and access information about a given Transport.
 *
 * @author KAoS Team
 * $Revision: 1.1 $
 */
public interface AgentHostingEnvironment
    extends Serializable
{
    /**
     * Obtain the AgentHostingEnvironment's globally unique identifier.
     *
     * @return String representing the AgentHostingEnvironment's guid.
     */
    public String getGUID();
    
    /**
     * Set the AgentHostingEnvironment's globally unique identifier.
     *
     * @param actorGUID   String containing AgentHostingEnvironment's globally unique identifier.
     */
    public void setGUID(String actorGUID);
    
    /**
     * Obtain guarded/unguarded status of this AgentHostingEnvironment.
     *
     * @return boolean indicating whether the AgentHostingEnvironment is guarded. 
     */
    public boolean isGuarded();
   
    /** 
     * Set the guarded/unguarded status of this AgentHostingEnvironment.
     *
     * @param guarded    The boolean indicating whether the AgentHostingEnvironment is guarded. 
     */
    public void setGuarded(boolean guarded);
    
    /** 
     * Set the number of hosted agents.
     *
     * @param num      int containing the number of hosted agents.
     */
    public void setNumberOfHostedAgents(int num);
   
    /**
     * Obtain the number of hosted agents.
     *
     * @return int      containing the number of hosted agents.
     */
    public int getNumberOfHostedAgent();
    
}
