/**
 * Last Modified by: $Author: auszok $
 * On: $Date: 2005/11/28 15:32:56 $
 */
 
package kaos.core.csi.extension;

import java.util.List;

/**
 * This interface defines methods to access name and ontological attributes associated with this component
 * 
 *   $Revision: 1.1 $
 */
public interface KAoSExtensionComponent
{
	/**
     * Return the associated ontological concepts for the KAoSExtensionComponent object.
     *      
     * @return  List containing names of the concepts the KAoSExtensionComponent is associated with.
     */
	public List getOntologicalAttributes();
	
	/**
     * Return the (unique) name of this KAoSExtensionComponent object.
     *      
     * @return  name of this component.
     */
	public String getName();
	
	/**
     * Set 'true/false', indicating the 'enabled/disabled' status of the component.
     *      
     * @param	status   boolean parameter to set the 'enabled/disabled' status to
     */
	public void setEnabledStatus(boolean status);
	
	/**
     * Return 'true/false', indicating the 'enabled/disabled' status of the component.
     *      
     * @return	a boolean parameter indicating the 'enabled/disabled' status of this component.
     */
	public boolean getEnabledStatus();	
}
