/**
 * Last Modified by: $Author: auszok $
 * On: $Date: 2005/12/09 13:21:27 $
 */
 
package kaos.core.csi.extension.classification;

import kaos.core.csi.extension.KAoSExtensionComponent;
import kaos.ontology.management.UnknownConceptException;
import kaos.policy.information.OntologyInterfaces;					   
 
/**
 *   Interface to instance classfiers
 *
 *   $Revision: 1.3 $
 */
public interface InstanceClassifier extends KAoSExtensionComponent
{                                  
    /**
     * Check if the instance is in of the given class 
     *
     * @param className                 name of the class (as url to teh ontology concept)
     * 
     * @param classDesc                 the optional class description
     * 
     * @param instance				    the instance to be clissified
     * 
     * @param instDesc					the optional instance description	
     *
     * @return                          True if the instance is of the specified class, false if not.
     *
     * @throws UnknownConceptException  if the provided concepts are unknown
     */
    public boolean classify(String className, Object classDesc, String instance, Object instDesc) throws UnknownConceptException;
    
	/**
     * TODO: remove it when OntologyInterfaces become available in CSI
     * 
     * Set optional OntologyInterfaces to be used to retrive a missing ontology definition of not provided explicitly 
     * in the classify method arguments
     *
     * @param ontInterfaces             OntologyInterfaces to be used, if needed for instance classification.
     */
    public void setOntologyInterfaces(OntologyInterfaces ontInterfaces);
}
