/**
 * Last Modified by: $Author: rjeffers $
 * On: $Date: 2005/12/16 05:59:15 $
 */
package kaos.core.csi.usecase.legacy;

/**
 * Defines the operations to process legacy actions.
 * 
 * @author rjeffers
 *
 */
public interface LegacySystem {
	
	/**
	 * Accepts a request for a legacy action in the legacy system.
	 * 
	 * @param actionRequestorID		String containing the unique ID of the action requestor. 
	 * 
	 * @return boolean indicating success/failure of the action execution.
	 */
	public boolean legacyAction(String actionRequestorID);
	
	/**
	 * Accepts a request for another action in the legacy system.
	 * 
	 * @param actionRequestorID		String containing the unique ID of the action requestor. 
	 * 
	 * @return boolean indicating success/failure of the action execution.
	 */
	public boolean anotherLegacyAction(String actionRequestorID);
}
