/**
 * Last Modified by: $Author: rjeffers $
 * On: $Date: 2005/12/16 16:35:56 $
 */
package kaos.core.csi.usecase.legacy;


/**
 * Defines the operations to process legacy actions.
 * 
 * @author rjeffers
 *
 */
public class LegacySystemImpl 
	implements LegacySystem {
  
   
    public LegacySystemImpl(){
  
    }
    
	/** 
	 * Accepts a request for a legacy action in the legacy system.
	 * 
	 * @param actionRequestorID		String containing the unique ID of the action requestor. 
	 * 
	 * @return boolean indicating success/failure of the action execution.
	 */
	public boolean legacyAction(String actionRequestorID) {
		System.out.println("\n\n	****	Received request for legacy action from from:\n\t " + actionRequestorID + "\n");
		return true;
	}

	/**
	 * Accepts a request for another action in the legacy system.
	 * 
	 * @param actionRequestorID		String containing the unique ID of the action requestor. 
	 * 
	 * @return boolean indicating success/failure of the action execution.
	 */
	public boolean anotherLegacyAction(String actionRequestorID)
	{
		System.out.println("\n\n	****	Received request for another legacy action from from:\n\t " + actionRequestorID + "\n");
		return true;
	}
	/**
	 * @param args
	 */
	public static void main(String[] args) {
	
	}

}
