/**
 * Last Modified by: $Author: rjeffers $
 * On: $Date: 2006/01/27 22:04:30 $
 */

package kaos.core.csi.util.tcpSupport;

import java.net.*;
import javax.swing.*;

import kaos.core.csi.util.xmlSupport.XMLToCSIConstants;
import javax.swing.JTextField;
import javax.swing.border.BevelBorder;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.BorderLayout;
import java.awt.event.*;

import kaos.core.csi.util.xmlSupport.XMLToCSITranslator;


public class KAoSCSIClient
     implements ResponseReceiver   
{
	protected ClientCommHandler _clientHandler;
	protected JTextField _x;
	protected JTextField _y;
	protected JTextField _regField;
	protected JTextField _commandField;
	protected JTextField _getPoseField;
	protected JTextField _authorizationField;
	protected JTextField _obligationField;
	protected String    _xmlTransmission ;
    private long        _startTime;
	
	    
	public KAoSCSIClient(String host, int port, String xmlRegisterName, String xmlCommandFileName, String xmlGetPoseFileName)
		throws Exception
	{
		Socket socket = new Socket (host, port);
		_clientHandler = new ClientCommHandler(socket, this);
		_clientHandler.start();
		_xmlTransmission = XMLToCSIConstants.XML_TRANSMITTED_FILE_CONTENT; // by default, transmit the String representation
		                                                                   // of the xml files (vs the file name)
	
		buildGUI(xmlRegisterName, xmlCommandFileName, xmlGetPoseFileName, null, null);	
	}
	
	public KAoSCSIClient(String host, 
			             int port,
			             String xmlRegisterName,
			             String xmlCommandFileName,
			             String xmlGetPoseFileName,
			             String xmlAuthorizeFileName,
			             String xmlGetObligationFileName)
	throws Exception
{
	Socket socket = new Socket (host, port);
	_clientHandler = new ClientCommHandler(socket, this);
	_clientHandler.start();
	_xmlTransmission = XMLToCSIConstants.XML_TRANSMITTED_FILE_CONTENT; // by default, transmit the String representation
	                                                                   // of the xml files (vs the file name)

	buildGUI(xmlRegisterName, xmlCommandFileName, xmlGetPoseFileName, xmlAuthorizeFileName, xmlGetObligationFileName);	
}
	
	///////////////////////////////////////////////////////////////////////  
    //  kaos.core.csi.util.tcpSupport.ResponseSender implementation
    /////////////////////////////////////////////////////////////////////// 
    public void receiveResponse(String msg)
	{
	    if ( ( msg.equals("ENDED-TEST")) ) { 
	        long endTime = System.currentTimeMillis();
		    System.out.println("\n  **** ENTIRE test duration:  " + (endTime - _startTime) +"ms\n" );
	    }
	    else {
		    System.out.println(msg);
		}
	}
	//  kaos.core.csi.util.tcpSuport.ResponseSender implementation end
	
    public void setXMLTransmissionType(String type)
    {
        _xmlTransmission = type;
    }
	private void buildGUI(final String xmlFileName, 
			              final String commdFileName,
			              final String getPoseFileName,
			              final String xmlAuthorizeFileName,
			              final String xmlGetObligationFileName)
	{
		// main panel
        JPanel panel = new JPanel();
        GridBagConstraints gbc = new GridBagConstraints();
        panel.setLayout(new GridBagLayout());
        panel.setBorder(BorderFactory.createBevelBorder(BevelBorder.RAISED));
		
		JButton sendBtn = new JButton("Command");
		sendBtn.addActionListener(new ActionListener() {
            public void actionPerformed (ActionEvent ae) {
				//String msg = "Request IVAN MoveTo " + _x.getText() + " " + _y.getText();
				System.out.println("\n  Command file name: " + _commandField.getText());
				String transmissionString = getTransmissionString(_commandField.getText() );
				System.out.println("\n  Transmission content:\n " + transmissionString + "\n");
				if ( transmissionString != null ) {
				    _clientHandler.sendString(transmissionString);	
				}
				//_clientHandler.sendString("1" +  _commandField.getText());
			}
		});
		
		_x = new JTextField("4.0");
		_y = new JTextField("4.0");
		
		JButton getPoseBtn = new JButton("Get Pose");
		getPoseBtn.addActionListener(new ActionListener() {
            public void actionPerformed (ActionEvent ae) {
				//String msg = "Query IVAN getPose";
				System.out.println("\n  GetPose file name: " + _getPoseField.getText());
				String transmissionString = getTransmissionString(_getPoseField.getText() );
				System.out.println("\n  Transmission content:\n " + transmissionString);
				if ( transmissionString != null ) {
				    _clientHandler.sendString(transmissionString);	
				}
			}
		});

        JButton registerBtn = new JButton("Register");
		registerBtn.addActionListener(new ActionListener() {
            public void actionPerformed (ActionEvent ae) {
                System.out.println("\n  Registration file name: " + _regField.getText());
				String transmissionString = getTransmissionString(_regField.getText());
				System.out.println("\n  Transmission content:\n " + transmissionString);
				if ( transmissionString != null ) {
				    _clientHandler.sendString(transmissionString);	
				}
			}
		});
		
		JButton authorizeBtn = new JButton("Authorize");
		authorizeBtn.addActionListener(new ActionListener() {
            public void actionPerformed (ActionEvent ae) {
                System.out.println("\n  Authorization file name: " + _authorizationField.getText());
				String transmissionString = getTransmissionString(_authorizationField.getText());
				System.out.println("\n  Transmission content:\n " + transmissionString);
				if ( transmissionString != null ) {
				    _clientHandler.sendString(transmissionString);	
				}
			}
		});
		
		JButton obligationBtn = new JButton("Get Obligations");
		obligationBtn.addActionListener(new ActionListener() {
            public void actionPerformed (ActionEvent ae) {
                System.out.println("\n  Obligation file name: " + _obligationField.getText());
				String transmissionString = getTransmissionString(_obligationField.getText());
				System.out.println("\n  Transmission content:\n " + transmissionString);
				if ( transmissionString != null ) {
				    _clientHandler.sendString(transmissionString);	
				}
			}
		});

		_regField = new JTextField(xmlFileName);
		_commandField = new JTextField(commdFileName);
		_getPoseField = new JTextField(getPoseFileName);
		_authorizationField = new JTextField(xmlAuthorizeFileName);
		_obligationField = new JTextField(xmlGetObligationFileName);
		
		// layout components
		gbc.gridx = 0;
		gbc.gridy = 0;
        gbc.fill = GridBagConstraints.BOTH;
		panel.add(sendBtn, gbc);
		gbc.gridx++;
        panel.add(_commandField, gbc);
    /*
		gbc.gridx++;
		panel.add(_x, gbc);
		
		gbc.gridx ++;
		panel.add(_y, gbc);
	*/	
		gbc.gridx = 0;
		gbc.gridy++;
        gbc.fill = GridBagConstraints.BOTH;
		panel.add(getPoseBtn, gbc);
		gbc.gridx++;
        panel.add(_getPoseField, gbc);
		
		gbc.gridx = 0;
		gbc.gridy++;
        gbc.fill = GridBagConstraints.BOTH;
		panel.add(registerBtn, gbc);
		gbc.gridx++;
		panel.add(_regField, gbc);
		
		gbc.gridx = 0;
		gbc.gridy++;
        gbc.fill = GridBagConstraints.BOTH;
		panel.add(authorizeBtn, gbc);
		gbc.gridx++;
		panel.add(_authorizationField, gbc);
		
		gbc.gridx = 0;
		gbc.gridy++;
        gbc.fill = GridBagConstraints.BOTH;
		panel.add(obligationBtn, gbc);
		gbc.gridx++;
		panel.add(_obligationField, gbc);

		
		JFrame f = new JFrame("Java TCP Client");
        f.addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent e) {
				System.exit(0);
		}});

		f.getContentPane().add(panel, BorderLayout.CENTER);	            
       	f.pack();
       	f.setVisible(true);
	}	
	
	private String getTransmissionString(String fileName) 
	{
	    String transmissionString = null;
	    if ( _xmlTransmission.equals( XMLToCSIConstants.XML_TRANSMITTED_FILE_CONTENT)) {
	        //transmissionString = getXMLFileAsString(fileName);
	        transmissionString = XMLToCSITranslator.getXMLFileAsString(fileName);
	    }
	    else {
	        transmissionString = fileName;
	    }
	    
	    if ( transmissionString == null ) {
	    	System.out.println("\n	*** Transmission content is null! Unable to complete request.");
	    	return null;
	    }
	    return getTransmissionHeader() + "\n" + transmissionString;
	}
	
	private String getTransmissionHeader()
	{
	    if ( _xmlTransmission.equals( XMLToCSIConstants.XML_TRANSMITTED_FILE_CONTENT)) {
		    return XMLToCSIConstants.XML_TRANSMISSION_HEADER + XMLToCSIConstants.XML_TRANSMITTED_FILE_CONTENT;
	    }
	    else {
	        return XMLToCSIConstants.XML_TRANSMISSION_HEADER + XMLToCSIConstants.XML_TRANSMITTED_FILE_NAME;
	    }

	}
	
	public void testFileSend(int testCount)
	{
	    // Keeps time of begining and end of this operation
        long timeBegin, timeEnd;
        String type;
        if ( _xmlTransmission.equals( XMLToCSIConstants.XML_TRANSMITTED_FILE_CONTENT)) {
	        type = "XML file content will be transmitted";
	    }
	    else {
	        type = "XML file name will be transmitted; file will be parsed on server side.";
	    }
	    String transmissionString = getTransmissionString(_regField.getText());
	    if ( transmissionString == null ) return;
	    System.out.println("\n  Registration file name: " + _regField.getText() 
	                     + "\n  Transmission type: " + type 
	                     + "\n  Test count: " + testCount
	                     + "\n  String to transmit: \n" + transmissionString );  
	                     
        _clientHandler.sendString("START-TEST");	
	    _startTime = System.currentTimeMillis();
	    //System.out.println("\n      *** testFileSend: starting time: " + timeBegin);
	    for (int i = 0; i < testCount; i++) {
		    _clientHandler.sendString(transmissionString);	
			
	    }// end for
	    _clientHandler.sendString("END---TEST");
	    timeEnd = System.currentTimeMillis();
        System.out.println("\n      *** testFileSend: Client ended sending strings.  Duration: " + (timeEnd - _startTime) +"ms\n");
	}
	
	//test driver //////////////////////////////////////////////////////////////////    
    public static void main (String[] args)
    {
        //verify user has specified a host and port
		if (args.length < 2) {
            System.out.println ("Usage: host port");
            return;
        }
        String  commandFileDefault=System.getProperty("xml.command");
        if ( commandFileDefault == null ) commandFileDefault = "";
        
        String  registerFileDefault=System.getProperty("xml.register");
        if ( registerFileDefault == null ) registerFileDefault = "";
        
        String  getPoseFileDefault=System.getProperty("xml.get.pose");
        if ( getPoseFileDefault == null ) getPoseFileDefault = "";
        
        String  authorizeDefault=System.getProperty("xml.authorize");
        if ( authorizeDefault == null ) authorizeDefault = "";
        
        String  getobligationDefault=System.getProperty("xml.get.obligations");
        if ( getobligationDefault == null ) getobligationDefault = "";
        
        String  xmlFileNameTransmission=System.getProperty("xml.transmit.file.name");
        
        
		try{
			KAoSCSIClient cc = new KAoSCSIClient(args[0], 
			                                     Integer.parseInt (args[1]), 
			                                     registerFileDefault, 
			                                     commandFileDefault,
			                                     getPoseFileDefault,
			                                     authorizeDefault,
			                                     getobligationDefault);  
			 if ( xmlFileNameTransmission != null ) 
			    cc.setXMLTransmissionType(xmlFileNameTransmission);
			  
			 if ( args.length == 3) 
			    cc.testFileSend(10);
			 else if ( args.length == 4 ) {
			    String times = args[3];
			    int howManyTimes = 10;
			    try {
			        howManyTimes = Integer.parseInt(args[3]);
			    }
			    catch(Exception e){
			        e.printStackTrace();
			    }
			    cc.testFileSend(howManyTimes);
			 }
			    
			    
			 
		}
		catch(Exception e){
			e.printStackTrace();
		}
	}	
}