package kaos.ontology.vocabulary;

import kaos.ontology.util.OntologyLanguageTagSelector;

/**
 * Class generated automatically by kaos.tools.OWLOntologyJavaMapper.
 * Provides static methods to obtain URI's for the ontology concepts and properties.
 */
final public class ActionStatusConcepts
{
	final private static String ActionStatusOwlURL = "http://ontology.ihmc.us/ActionStatus.owl#";

    public static String ActionStatusOwlURL() 
	{
		return OntologyLanguageTagSelector.selectLanguageForTag(ActionStatusOwlURL); 
	}

	// Concepts
    public static final String Failure = OntologyLanguageTagSelector.selectLanguageForTag(ActionStatusOwlURL + "Failure");
    public static final String Feasible = OntologyLanguageTagSelector.selectLanguageForTag(ActionStatusOwlURL + "Feasible");
    public static final String Started = OntologyLanguageTagSelector.selectLanguageForTag(ActionStatusOwlURL + "Started");
    public static final String Obliged = OntologyLanguageTagSelector.selectLanguageForTag(ActionStatusOwlURL + "Obliged");
    public static final String Candidate = OntologyLanguageTagSelector.selectLanguageForTag(ActionStatusOwlURL + "Candidate");
    public static final String Authorized = OntologyLanguageTagSelector.selectLanguageForTag(ActionStatusOwlURL + "Authorized");
    public static final String Forbiden = OntologyLanguageTagSelector.selectLanguageForTag(ActionStatusOwlURL + "Forbiden");
    public static final String Completed = OntologyLanguageTagSelector.selectLanguageForTag(ActionStatusOwlURL + "Completed");
    public static final String Planned = OntologyLanguageTagSelector.selectLanguageForTag(ActionStatusOwlURL + "Planned");
    public static final String Requested = OntologyLanguageTagSelector.selectLanguageForTag(ActionStatusOwlURL + "Requested");
    public static final String ObligationUnfulfillmentReason = OntologyLanguageTagSelector.selectLanguageForTag(ActionStatusOwlURL + "ObligationUnfulfillmentReason");
    public static final String ActionStatus = OntologyLanguageTagSelector.selectLanguageForTag(ActionStatusOwlURL + "ActionStatus");
    public static final String Aborted = OntologyLanguageTagSelector.selectLanguageForTag(ActionStatusOwlURL + "Aborted");
    public static final String Finished = OntologyLanguageTagSelector.selectLanguageForTag(ActionStatusOwlURL + "Finished");
    public static final String UnfulfilledObliged = OntologyLanguageTagSelector.selectLanguageForTag(ActionStatusOwlURL + "UnfulfilledObliged");
    public static final String Refused = OntologyLanguageTagSelector.selectLanguageForTag(ActionStatusOwlURL + "Refused");
    public static final String Accepted = OntologyLanguageTagSelector.selectLanguageForTag(ActionStatusOwlURL + "Accepted");
    public static final String ActionPolicyStatus = OntologyLanguageTagSelector.selectLanguageForTag(ActionStatusOwlURL + "ActionPolicyStatus");

    public static String Failure() { return Failure; };
    public static String Feasible() { return Feasible; };
    public static String Started() { return Started; };
    public static String Obliged() { return Obliged; };
    public static String Candidate() { return Candidate; };
    public static String Authorized() { return Authorized; };
    public static String Forbiden() { return Forbiden; };
    public static String Completed() { return Completed; };
    public static String Planned() { return Planned; };
    public static String Requested() { return Requested; };
    public static String ObligationUnfulfillmentReason() { return ObligationUnfulfillmentReason; };
    public static String ActionStatus() { return ActionStatus; };
    public static String Aborted() { return Aborted; };
    public static String Finished() { return Finished; };
    public static String UnfulfilledObliged() { return UnfulfilledObliged; };
    public static String Refused() { return Refused; };
    public static String Accepted() { return Accepted; };
    public static String ActionPolicyStatus() { return ActionPolicyStatus; };

	// Properties
    public static final String hasReasonForUnfulfillment = OntologyLanguageTagSelector.selectLanguageForTag(ActionStatusOwlURL + "hasReasonForUnfulfillment");
    public static final String involvedPolicy = OntologyLanguageTagSelector.selectLanguageForTag(ActionStatusOwlURL + "involvedPolicy");
    public static final String hasRelationToTrigger = OntologyLanguageTagSelector.selectLanguageForTag(ActionStatusOwlURL + "hasRelationToTrigger");
    public static final String hasDeadlineToFinish = OntologyLanguageTagSelector.selectLanguageForTag(ActionStatusOwlURL + "hasDeadlineToFinish");
    public static final String hasStatus = OntologyLanguageTagSelector.selectLanguageForTag(ActionStatusOwlURL + "hasStatus");
    public static final String hasBeenTrigerredBy = OntologyLanguageTagSelector.selectLanguageForTag(ActionStatusOwlURL + "hasBeenTrigerredBy");
    public static final String hasDeadlineToStart = OntologyLanguageTagSelector.selectLanguageForTag(ActionStatusOwlURL + "hasDeadlineToStart");

    public static String hasReasonForUnfulfillment() { return hasReasonForUnfulfillment; };
    public static String involvedPolicy() { return involvedPolicy; };
    public static String hasRelationToTrigger() { return hasRelationToTrigger; };
    public static String hasDeadlineToFinish() { return hasDeadlineToFinish; };
    public static String hasStatus() { return hasStatus; };
    public static String hasBeenTrigerredBy() { return hasBeenTrigerredBy; };
    public static String hasDeadlineToStart() { return hasDeadlineToStart; };

	// Instances
    public static final String DefaultObligedStatus = OntologyLanguageTagSelector.selectLanguageForTag(ActionStatusOwlURL + "DefaultObligedStatus");
    public static final String DefaultAcceptedActionStatus = OntologyLanguageTagSelector.selectLanguageForTag(ActionStatusOwlURL + "DefaultAcceptedActionStatus");
    public static final String DefaultFeasibleActionStatus = OntologyLanguageTagSelector.selectLanguageForTag(ActionStatusOwlURL + "DefaultFeasibleActionStatus");
    public static final String ObligedActorNotFound = OntologyLanguageTagSelector.selectLanguageForTag(ActionStatusOwlURL + "ObligedActorNotFound");
    public static final String ObligedActorNotLocatable = OntologyLanguageTagSelector.selectLanguageForTag(ActionStatusOwlURL + "ObligedActorNotLocatable");
    public static final String ObligedActorNotReachable = OntologyLanguageTagSelector.selectLanguageForTag(ActionStatusOwlURL + "ObligedActorNotReachable");
    public static final String DefaultCandidateActionStatus = OntologyLanguageTagSelector.selectLanguageForTag(ActionStatusOwlURL + "DefaultCandidateActionStatus");
    public static final String DefaultStartedActionStatus = OntologyLanguageTagSelector.selectLanguageForTag(ActionStatusOwlURL + "DefaultStartedActionStatus");
    public static final String DefaultAuthorizedStatus = OntologyLanguageTagSelector.selectLanguageForTag(ActionStatusOwlURL + "DefaultAuthorizedStatus");
    public static final String ObligationConstrainViolated = OntologyLanguageTagSelector.selectLanguageForTag(ActionStatusOwlURL + "ObligationConstrainViolated");
    public static final String DefaultForbidenStatus = OntologyLanguageTagSelector.selectLanguageForTag(ActionStatusOwlURL + "DefaultForbidenStatus");
    public static final String DefaultFinishedActionStatus = OntologyLanguageTagSelector.selectLanguageForTag(ActionStatusOwlURL + "DefaultFinishedActionStatus");
    public static final String LocationServiceNotFound = OntologyLanguageTagSelector.selectLanguageForTag(ActionStatusOwlURL + "LocationServiceNotFound");
    public static final String TriggerActionNotAuthorized = OntologyLanguageTagSelector.selectLanguageForTag(ActionStatusOwlURL + "TriggerActionNotAuthorized");
    public static final String DefaultCompletedActionStatus = OntologyLanguageTagSelector.selectLanguageForTag(ActionStatusOwlURL + "DefaultCompletedActionStatus");
    public static final String DefaultPlannedActionStatus = OntologyLanguageTagSelector.selectLanguageForTag(ActionStatusOwlURL + "DefaultPlannedActionStatus");
    public static final String DefaultFailureActionStatus = OntologyLanguageTagSelector.selectLanguageForTag(ActionStatusOwlURL + "DefaultFailureActionStatus");
    public static final String DefaultAbortedActionStatus = OntologyLanguageTagSelector.selectLanguageForTag(ActionStatusOwlURL + "DefaultAbortedActionStatus");
    public static final String DefaultActionPolicyStatus = OntologyLanguageTagSelector.selectLanguageForTag(ActionStatusOwlURL + "DefaultActionPolicyStatus");
    public static final String DefaultUnfulfilledObligedStatus = OntologyLanguageTagSelector.selectLanguageForTag(ActionStatusOwlURL + "DefaultUnfulfilledObligedStatus");
    public static final String DefaultRefusedActionStatus = OntologyLanguageTagSelector.selectLanguageForTag(ActionStatusOwlURL + "DefaultRefusedActionStatus");
    public static final String DefaultRequestedActionStatus = OntologyLanguageTagSelector.selectLanguageForTag(ActionStatusOwlURL + "DefaultRequestedActionStatus");

    public static String DefaultObligedStatus() { return DefaultObligedStatus; };
    public static String DefaultAcceptedActionStatus() { return DefaultAcceptedActionStatus; };
    public static String DefaultFeasibleActionStatus() { return DefaultFeasibleActionStatus; };
    public static String ObligedActorNotFound() { return ObligedActorNotFound; };
    public static String ObligedActorNotLocatable() { return ObligedActorNotLocatable; };
    public static String ObligedActorNotReachable() { return ObligedActorNotReachable; };
    public static String DefaultCandidateActionStatus() { return DefaultCandidateActionStatus; };
    public static String DefaultStartedActionStatus() { return DefaultStartedActionStatus; };
    public static String DefaultAuthorizedStatus() { return DefaultAuthorizedStatus; };
    public static String ObligationConstrainViolated() { return ObligationConstrainViolated; };
    public static String DefaultForbidenStatus() { return DefaultForbidenStatus; };
    public static String DefaultFinishedActionStatus() { return DefaultFinishedActionStatus; };
    public static String LocationServiceNotFound() { return LocationServiceNotFound; };
    public static String TriggerActionNotAuthorized() { return TriggerActionNotAuthorized; };
    public static String DefaultCompletedActionStatus() { return DefaultCompletedActionStatus; };
    public static String DefaultPlannedActionStatus() { return DefaultPlannedActionStatus; };
    public static String DefaultFailureActionStatus() { return DefaultFailureActionStatus; };
    public static String DefaultAbortedActionStatus() { return DefaultAbortedActionStatus; };
    public static String DefaultActionPolicyStatus() { return DefaultActionPolicyStatus; };
    public static String DefaultUnfulfilledObligedStatus() { return DefaultUnfulfilledObligedStatus; };
    public static String DefaultRefusedActionStatus() { return DefaultRefusedActionStatus; };
    public static String DefaultRequestedActionStatus() { return DefaultRequestedActionStatus; };
}
